package com.brilliance.isc.health;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 用于Consul的健康检查类, 不可删除; 容器云平台的探针也配置这个url
 *
 */
@RefreshScope
@RestController
public class HealthController {

	@Value("${health.flag:true}")
	private String flag;

	@GetMapping("/isc/health")
	public String healthInfo() {
		if ("true".equalsIgnoreCase(flag)) {
			return "UP";
		} else {
			return "DOWN";
		}
	}

}
