package com.brilliance.isc.funds.basesel.ftdsel.resource;

import com.brilliance.isc.bo.FtdVo;
import com.brilliance.isc.funds.basesel.ftdsel.service.FtdselService;
import com.brilliance.isc.funds.basesel.trncod.service.TrncodService;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import javax.annotation.Resource;
import java.util.Map;

@RestController
@RequestMapping("/ftdsel")
public class FtdselController {

    @Resource
    private FtdselService ftdselService;

    @Resource
    private TrncodService trncodService;

    @RequestMapping("/query")
    public ResponseSet list(@RequestBody FtdVo vo) {
        return ResponseSet.simpleSuccess(
                ftdselService.query(vo)
        );
    }
    /**
     * 处理按钮查看能够进行的交易
     *
     */
    @RequestMapping("/dealWithByInr")
    public ResponseSet dealWithByInr(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(trncodService.dealWithByInr(trnCodeQueryVo));
    }

    /**
     * 详情页面初始化
     */
    @RequestMapping("/selectXxdByPrimaryKey")
    public ResponseSet selectXxdByPrimaryKey(@RequestBody Map<String,String> map) {
        return ResponseSet.simpleSuccess(trncodService.selectXxdByPrimaryKey(map));
    }


}
