package com.brilliance.isc.funds.fttpcm.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.bo.funds.FttpcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtfopStoreBo;
import com.brilliance.isc.funds.fttpcm.service.FttpcmTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FttpcmStructMapper;
import com.brilliance.isc.funds.vo.funds.FttpcmStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtfopStoreVo;import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.apache.ibatis.transaction.Transaction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;


@RestController
@RequestMapping("/fttpcm")
@Api("头寸调拨登记")
public class FttpcmResource extends AbstractTransactionController<FttpcmStoreVo> {
    @Resource
    private FttpcmStructMapper fttpcmStructMapper;
    public IStructMapper getStructMapper() {
        return fttpcmStructMapper;
    }
    @Resource(name = "fttpcm.transaction")
    FttpcmTransactionServiceImpl fttpcmTransactionService;

    @Autowired
    private SettleContext settleContext;
    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody FttpcmStoreVo fttpcmStoreVo) {
        String ref = fttpcmTransactionService.getRef(fttpcmStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }

  @PostMapping("/defaultRateN1000")
    public ResponseSet defaultRateN1000(@RequestBody FxtfopStoreVo fxtfopStoreVo) {
        try {
            settleContext.loadSettleSession("FTTPCM","","");
            fttpcmTransactionService.defaultRateN1000(fxtfopStoreVo);
            return ResponseSet.simpleSuccess(fxtfopStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }

    @PostMapping("/defaultCalculateN1100")
    public ResponseSet defaultCalculateN1100(@RequestBody FttpcmStoreVo fttpcmStoreVo) {
        try {
            settleContext.loadSettleSession("FTTPCM","","");
            fttpcmTransactionService.defaultCalculateN1100(fttpcmStoreVo);
            return ResponseSet.simpleSuccess(fttpcmStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }


}
