package com.brilliance.isc.funds.fxtfcn.register.settle;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fxtfcn.settleRegister")
public class FxtfcnSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;


    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private FxToolComponent fxToolComponent;

    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();

        Fxdgrp fxdgrp = fxToolComponent.getFxdgrpByInr(rec.getObjinr());


        //取得上下文
        setmodVo.setDoccur(rec.getCancur());
        setmodVo.setDocamt(rec.getCanamt());
        SetglgVo setglg = setmodVo.getSetglg();

        setglgService.setglgClrAmount ( setglg,"TRN" );

        //如果ACT角色未赋值，则APL为我行账户行
        String acctyp = NULLSTR;
        String act1 = NULLSTR;
        String cdtKey = NULLSTR;
        String act2 = NULLSTR;
        if( ptsptaToolComponent.ptsIsRolSet(fxdgrp.getAct()) )
        {
            //D: 114(或116)外币
            if( ptsptaToolComponent.IsDemestic(fxdgrp.getAct()) )
            {
                acctyp = "DB-CLR";
                act1 =glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getAct().getPts().getPtyinr(), setmodVo.getSetamt() );
                cdtKey = setglgService.setglgAddAmount (  setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "DBD", "C", act1, "" );
            }
            else
            {
                acctyp = "DB-FOG";
                act2 =glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getAct().getPts().getPtyinr(),  setmodVo.getSetamt() );
                cdtKey = setglgService.setglgAddAmount (  setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act2, "" );
            }
        }
        else
        {
            //D: 114(或116)外币
            if(  ptsptaToolComponent.IsDemestic(fxdgrp.getApl()) )
            {
                acctyp = "DB-CLR";
                act1 = glemodService.getAvailAcc ( acctyp,setmodVo.getDoccur(), fxdgrp.getApl().getPts().getPtyinr(), setmodVo.getSetamt() );
                cdtKey = setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "DBD", "C", act1, "" );
            }
            else
            {
                acctyp = "DB-FOG";
                act2 = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getApl().getPts().getPtyinr(),  setmodVo.getSetamt() );
                cdtKey = setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act2, "" );
            }
        }
        //C:13903外币
        /**
         $Act2 = SETMOD\\GLEMOD.GetAvailAcc ( "FT-FXR", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )

         **/
        act2 = glemodService.getAvailAcc ( "FT-FCR", setmodVo.getDoccur(), "",  setmodVo.getSetamt() );
        cdtKey =setglgService.setglgAddAmount (  setglg,"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "FTC", "C", act2, "" );
        //###############################
        //!买入
        //!
        //贷：281101代客即期外汇买卖   （A外币）
        //借：281105外汇买卖对外平盘    （A外币）
        //!------------------------------
        //!卖出
        //!
        //!
        //借：281105外汇买卖对外平盘    （B外币）
        //贷：281101代客即期外汇买卖   （B外币）
        //###############################
        //D 281105
        String act3 = glemodService.getAvailAcc (  "FX-ELQ",setmodVo.getDoccur(), "",  setmodVo.getSetamt() );
        /**
         $DdtKey = \\SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", SETMOD\\DOCCUR, SETMOD\\SETAMT, "", "FXD", "C", $Act3, "" )

         **/
        String ddtKey = setglgService.setglgAddAmount ( setglg,"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "FXD", "A", act3, "" );
        //C:281101
        String act4 = glemodService.getAvailAcc ( "FX-EXS",setmodVo.getDoccur(), "", setmodVo.getSetamt() );
        /**
         $CbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "OWN", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "SET", "FXC", "F", $Act4, "SET" )

         **/
        String cbtKey = setglgService.setglgAddAmount (  setglg,"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "FXC", "A", act4, "" );
        /**
         endif

         **/
        setmodService.setglgAllValDat (setmodVo,fxdgrp.getRec().getValdat(), "D" );

    }



}
