package com.brilliance.isc.funds.fxtfop.register.settle;

import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.register.settle.common.DftcreSettleRegister;
import com.brilliance.isc.common.register.settle.common.TrtcreSettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import  com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fxtfop.settleRegister")
public class FxtfopSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;

    @Autowired
    private GlemodService glemodService;


    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
        //dftcreSettleRegister.registerSettlement(setmodVo);
        //trtcreSettleRegister.registerSettlement(setmodVo);
    }

    /**
     * source:fxtfop.0010.script
     */
    private void transRegister(SetmodVo setmodVo) {

        //取得上下文
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();
        String maxCur=NULLSTR;
        BigDecimal maxAmt = BigDecimal.ZERO;
        String nom1Cur = NULLSTR;
        BigDecimal nom1Amt = BigDecimal.ZERO;

        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
            maxCur= setmodVo.getCbsMap().get("MAX").getCur();
        }

        if (setmodVo.getCbsMap().get("NOM1") != null) {
            nom1Amt = setmodVo.getCbsMap().get("NOM1").getAmt();
            nom1Cur= setmodVo.getCbsMap().get("NOM1").getCur();
        }
        setmodVo.setDoccur(maxCur);
        setmodVo.setDocamt(maxAmt);
        setmodVo.setOpnamt(maxAmt);

        SetglgVo setglg = setmodVo.getSetglg();
        setglgService.setglgClrAmount(setglg, "TRN");
        setglgService.setglgClrAmount(setglg, "SET");

        String act1 = NULLSTR;
        String ddtKey = NULLSTR;
        String act4 = NULLSTR;
        String cbtKey = NULLSTR;
        if( ! MdaUtils.isEmpty(nom1Amt) && ! MdaUtils.isEmpty(rec.getFxtyp() ))
        {
            //D 281101
            act1=glemodService.getAvailAcc( "FX-EXS",maxCur,"", setmodVo.getSetamt());

            ddtKey =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", maxCur,  setmodVo.getSetamt(), "", "FXD", "C", act1, "" );
            //C:281105
            act4 = glemodService.getAvailAcc ( "FX-ELQ",maxCur, "", setmodVo.getSetamt() );
            cbtKey = setglgService.setglgAddAmount ( setglg,"SET", "OWN", maxCur,  setmodVo.getSetamt().negate(), "SET", "FXC", "F", act4, "SET" );
        }

    }
}
