package com.brilliance.isc.funds.transfer.transaction;


import com.brilliance.isc.funds.bo.funds.FttpcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtfcmStoreBo;
import com.brilliance.isc.funds.vo.funds.FttpcmStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtfcmStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

@Mapper(componentModel = "spring")
public interface FttpcmStructMapper extends IBaseStructMapper<FttpcmStoreBo, FttpcmStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtfcmStructMapper INSTANCE = Mappers.getMapper(FxtfcmStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FttpcmStoreBo voTransferToBo(FttpcmStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FttpcmStoreVo vo, @MappingTarget FttpcmStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FttpcmStoreVo boTransferToVo(FttpcmStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FttpcmStoreBo bo, @MappingTarget FttpcmStoreVo vo);
}
